// This is very funny piece of code :)). This is a "fake" pokey template.

extern BYTE channels_mask[4];
extern int wavetable[ 256 ];
extern int selected_output_type;

namespace NAMESPACENAME {

BYTE IRQ_EN;
BYTE IRQ_ST;
BYTE IRQ_line;
bool generateIRQ0;

const double cutFreq = 24000.0 / 44100.0;
const int samplerRate = 0x2836D6; // (1773447 / 44100) * 65536;
const int samplerRateOver = 0xA0DB5; // (1773447 / 176400) * 65536;

//const double fir_coefs[] = {	 0.02362928,
//								 0.06994829,
//								 0.15582607,
//								 0.20745997,
//								 0.22630991,
//								 0.20745997,
//								 0.15582607,
//								 0.06994829,
//								 0.02362928
//							};

//const double fir_coefs[] = {
//								-0.0016428705,
//								-0.0081876371,
//								-0.0195493821,
//								-0.0341334931,
//								-0.0439199360,
//								-0.0383535816,
//								-0.0062491739,
//								 0.0475438079,
//								 0.1187789531,
//								 0.1856186659,
//								 0.2261832813,
//								 0.2261832813,
//								 0.1856186659,
//								 0.1187789531,
//								 0.0475438079,
//								-0.0062491739,
//								-0.0383535816,
//								-0.0439199360,
//								-0.0341334931,
//								-0.0195493821,
//								-0.0081876371,
//								-0.0016428705,
//							};

const double fir_coefs[] = {
								-0.064961917995364035,
								-0.033993817009977716,
								 0.003034721778428980,
								 0.161777919034737400,
								 0.233382400945426980,
								 0.261209626352434500,
								 0.233382400945426980,
								 0.161777919034737400,
								 0.003034721778428980,
								-0.033993817009977716,
								-0.064961917995364035,
							};

double fir_buffer[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
double RC_capacitor_charge = 0.0;
double RC_capacitor_output = 0.0;
const double RC_capacitor_discharge_relaxation = 0.9993;

double fir_basic( double input )
{
	int ntaps = sizeof(fir_coefs) / sizeof(double);

	fir_buffer[0] = input;

	double accum = 0;
	for( int ii = 0; ii < ntaps; ii++ )
		accum += fir_coefs[ii] * fir_buffer[ii];

	for( int ii = ntaps - 2; ii >= 0; ii-- )
		fir_buffer[ii + 1] = fir_buffer[ii];

	return accum;
}

int sndBufPtrUpp;

int oldValI = 0;
double oldVal=0.0;
int delay = 0;

class Audctl
{
public:
	union
	{
		BYTE value;
		struct
		{
			BYTE	Freq15k:1;
			BYTE	HighPass1:1;
			BYTE	HighPass0:1;
			BYTE	Double23:1;
			BYTE	Double01:1;
			BYTE	HiClock2:1;
			BYTE	HiClock0:1;
			BYTE	Use9Poly:1;
		};
	};
	Audctl& operator = ( BYTE v )
	{
		value = v;
		return *this;
	}
	operator BYTE() const
	{
		return value;
	}
};

Audctl AUDCTL;
int pcc1564,noiseAND,pokeyClockCounter64k;

DWORD pokeyClockCounter;
DWORD poly4Counter,poly5Counter,poly4_5Counter;

BYTE poly9[511];
BYTE poly17[0x20000];
BYTE poly4_b[36000]; // minimum size is 312*114+15
BYTE poly5_b[36000]; // minimum size is 312*114+31
BYTE poly4_5_b[37000]; // minimum size is 312*114+465

BYTE poly4[15] = {
0, 15, 15, 0, 0, 15, 0, 15, 0, 0, 0, 0, 15, 15, 15
};

BYTE poly5[31] = {
15, 15, 15, 15, 0, 15, 15, 0, 15, 0, 0, 15, 15, 0, 0, 0, 0, 0, 15, 15, 15, 0, 0, 15, 0, 0, 0, 15, 0, 15, 0
};

int divideByN[4];
int divideByN_Latch[4];
int divideByN_Latch2[4];
int divideByN_Latch2_P[4];
BYTE switch_J2_signal_Q[4];
BYTE signal_state_out[4];
BYTE switch_J3_Q_state[4];
BYTE switch_J3_Q_stateAND[4];
BYTE audioControl_Latch[4];
BYTE audioControl_Latch2[4];
BYTE audioControl_Latch_Digi[4];
BYTE freq_sequre[4];

void (*Channel0Distortion)(void);
void (*Channel1Distortion)(void);
void (*Channel2Distortion)(void);
void (*Channel3Distortion)(void);

//---
void channel0_0( void )
{
	if( poly5_b[ poly5Counter + pokeyClockCounter ]!=0 )
		signal_state_out[0] = poly17[ pokeyClockCounter & noiseAND ];
}
void channel0_2( void )
{
	signal_state_out[0] = signal_state_out[0] ^ poly5_b[ poly5Counter + pokeyClockCounter ];
}
void channel0_4( void )
{
	if( poly5_b[ poly5Counter + pokeyClockCounter ]!=0 )
		signal_state_out[0] = poly4_b[ poly4Counter + pokeyClockCounter ];
}
void channel0_8( void )
{
	if( noiseAND == 0x1FFFF )
		signal_state_out[0] = poly17[ pokeyClockCounter & noiseAND ];
	else
		signal_state_out[0] = poly9[ pokeyClockCounter % 511 ];
}
void channel0_A( void )
{
	signal_state_out[0] = signal_state_out[0] ^ 15;
}
void channel0_C( void )
{
	signal_state_out[0] = poly4_b[ pokeyClockCounter + poly4Counter ];
}
//---
void channel1_0( void )
{
	if( poly5_b[ poly5Counter + pokeyClockCounter ]!=0 )
		signal_state_out[1] = poly17[ pokeyClockCounter & noiseAND ];
}
void channel1_2( void )
{
	signal_state_out[1] = signal_state_out[1] ^ poly5_b[ poly5Counter + pokeyClockCounter ];
}
void channel1_4( void )
{
	if( poly5_b[ poly5Counter + pokeyClockCounter ]!=0 )
		signal_state_out[1] = poly4_b[ poly4Counter + pokeyClockCounter ];
}
void channel1_8( void )
{
	if( noiseAND == 0x1FFFF )
		signal_state_out[1] = poly17[ pokeyClockCounter & noiseAND ];
	else
		signal_state_out[1] = poly9[ pokeyClockCounter % 511 ];
}
void channel1_A( void )
{
	signal_state_out[1] = signal_state_out[1] ^ 15;
}
void channel1_C( void )
{
	signal_state_out[1] = poly4_b[ pokeyClockCounter + poly4Counter ];
}
//---
void channel2_0( void )
{
	if( poly5_b[ poly5Counter + pokeyClockCounter ]!=0 )
		signal_state_out[2] = poly17[ pokeyClockCounter & noiseAND ];
}
void channel2_2( void )
{
	signal_state_out[2] = signal_state_out[2] ^ poly5_b[ poly5Counter + pokeyClockCounter ];
}
void channel2_4( void )
{
	if( poly5_b[ poly5Counter + pokeyClockCounter ]!=0 )
		signal_state_out[2] = poly4_b[ poly4Counter + pokeyClockCounter ];
}
void channel2_8( void )
{
	if( noiseAND == 0x1FFFF )
		signal_state_out[2] = poly17[ pokeyClockCounter & noiseAND ];
	else
		signal_state_out[2] = poly9[ pokeyClockCounter % 511 ];
}
void channel2_A( void )
{
	signal_state_out[2] = signal_state_out[2] ^ 15;
}
void channel2_C( void )
{
	signal_state_out[2] = poly4_b[ pokeyClockCounter + poly4Counter ];
}
//---
void channel3_0( void )
{
	if( poly5_b[ poly5Counter + pokeyClockCounter ]!=0 )
		signal_state_out[3] = poly17[ pokeyClockCounter & noiseAND ];
}
void channel3_2( void )
{
	signal_state_out[3] = signal_state_out[3] ^ poly5_b[ poly5Counter + pokeyClockCounter ];
}
void channel3_4( void )
{
	if( poly5_b[ poly5Counter + pokeyClockCounter ]!=0 )
		signal_state_out[3] = poly4_b[ poly4Counter + pokeyClockCounter ];
}
void channel3_8( void )
{
	if( noiseAND == 0x1FFFF )
		signal_state_out[3] = poly17[ pokeyClockCounter & noiseAND ];
	else
		signal_state_out[3] = poly9[ pokeyClockCounter % 511 ];
}
void channel3_A( void )
{
	signal_state_out[3] = signal_state_out[3] ^ 15;
}
void channel3_C( void )
{
	signal_state_out[3] = poly4_b[ pokeyClockCounter + poly4Counter ];
}

void channel0_1( void )
{
	signal_state_out[0] = 15;
}
void channel1_1( void )
{
	signal_state_out[1] = 15;
}
void channel2_1( void )
{
	signal_state_out[2] = 15;
}
void channel3_1( void )
{
	signal_state_out[3] = 15;
}

typedef void (*funcPoint)(void);
funcPoint channelsDistorionTable0[16]=
	{ &channel0_0, &channel0_1, &channel0_2, &channel0_1, &channel0_4, &channel0_1, &channel0_2, &channel0_1, &channel0_8, &channel0_1, &channel0_A, &channel0_1, &channel0_C, &channel0_1, &channel0_A, &channel0_1 };
funcPoint channelsDistorionTable1[16]=
	{ &channel1_0, &channel1_1, &channel1_2, &channel1_1, &channel1_4, &channel1_1, &channel1_2, &channel1_1, &channel1_8, &channel1_1, &channel1_A, &channel1_1, &channel1_C, &channel1_1, &channel1_A, &channel1_1 };
funcPoint channelsDistorionTable2[16]=
	{ &channel2_0, &channel2_1, &channel2_2, &channel2_1, &channel2_4, &channel2_1, &channel2_2, &channel2_1, &channel2_8, &channel2_1, &channel2_A, &channel2_1, &channel2_C, &channel2_1, &channel2_A, &channel2_1 };
funcPoint channelsDistorionTable3[16]=
	{ &channel3_0, &channel3_1, &channel3_2, &channel3_1, &channel3_4, &channel3_1, &channel3_2, &channel3_1, &channel3_8, &channel3_1, &channel3_A, &channel3_1, &channel3_C, &channel3_1, &channel3_A, &channel3_1 };

typedef void (*OutputFunction)();

void OutputFunction_Atari()
{
	DWORD pomd; int pomi;
	pomd  = ((DWORD*)&switch_J3_Q_state[0])[0];
	pomd &= ((DWORD*)&switch_J3_Q_stateAND[0])[0];
	pomd ^= ((DWORD*)&signal_state_out[0])[0];
	pomd &= ((DWORD*)&freq_sequre[0])[0];
	pomd |= ((DWORD*)&audioControl_Latch_Digi[0])[0];
	pomd &= ((DWORD*)&audioControl_Latch2[0])[0];
	pomd &= ((DWORD*)&channels_mask[0])[0];
	pomd = (pomd >> 16) + pomd;
	int signal = (((pomd >> 8) + pomd) & 0x3F) * 1920;
	double RC_discharge = RC_capacitor_charge - (double)signal; 
	RC_capacitor_charge = signal; 
	RC_capacitor_output -= RC_discharge; 
	double filtered_output = fir_basic( (double)((int)RC_capacitor_output) ); 
	RC_capacitor_output *= RC_capacitor_discharge_relaxation; 
	delay++; if( (delay&3)==0 )
	{
		pomi = (int)( -filtered_output );
		if( pomi<-32767 ) pomi = -32767; else if( pomi>32767 ) pomi = 32767;
		sndBuf[sndBufPtr] = (WORD)pomi ;
		sndBufPtr = (sndBufPtr+sampleStep)&16383;
	}
}

void OutputFunction_PCMWave()
{
	DWORD pomd; int pomi;
	pomd  = ((DWORD*)&switch_J3_Q_state[0])[0];
	pomd &= ((DWORD*)&switch_J3_Q_stateAND[0])[0];
	pomd ^= ((DWORD*)&signal_state_out[0])[0];
	pomd &= ((DWORD*)&freq_sequre[0])[0];
	pomd |= ((DWORD*)&audioControl_Latch_Digi[0])[0];
	pomd &= ((DWORD*)&audioControl_Latch2[0])[0];
	pomd &= ((DWORD*)&channels_mask[0])[0];
	int signal = 0; 
	int ss0 = ((int)((pomd) & 15)); 
	if( (audioControl_Latch[0] & 0xB0) == 0xA0 ) 
	{
		int sso = (signal_state_out[0] & 1) << 7;
		if( divideByN_Latch2[0] != 0 )
			signal += wavetable[ (sso + (divideByN[0] * 128) / divideByN_Latch2[0]) & 255 ] * (audioControl_Latch2[0] & freq_sequre[0] & channels_mask[0]);
	}
	else 
		signal += ss0 * 1920; 
	int ss1 = ((int)((pomd >> 8) & 15)); 
	if( (audioControl_Latch[1] & 0xB0) == 0xA0 ) 
	{
		int sso = (signal_state_out[1] & 1) << 7;
		if( divideByN_Latch2[1] != 0 )
			signal += wavetable[ (sso + (divideByN[1] * 128) / divideByN_Latch2[1]) & 255 ] * (audioControl_Latch2[1] & freq_sequre[1] & channels_mask[1]);
	}
	else 
		signal += ss1 * 1920; 
	int ss2 = ((int)((pomd >> 16) & 15)); 
	if( (audioControl_Latch[2] & 0xB0) == 0xA0 ) 
	{
		int sso = (signal_state_out[2] & 1) << 7;
		if( divideByN_Latch2[2] != 0 )
			signal += wavetable[ (sso + (divideByN[2] * 128) / divideByN_Latch2[2]) & 255 ] * (audioControl_Latch2[2] & freq_sequre[2] & channels_mask[2]);
	}
	else 
		signal += ss2 * 1920; 
	int ss3 = ((int)((pomd >> 24) & 15)); 
	if( (audioControl_Latch[3] & 0xB0) == 0xA0 ) 
	{
		int sso = (signal_state_out[3] & 1) << 7;
		if( divideByN_Latch2[3] != 0 )
			signal += wavetable[ (sso + (divideByN[3] * 128) / divideByN_Latch2[3]) & 255 ] * (audioControl_Latch2[3] & freq_sequre[3] & channels_mask[3]);
	}
	else 
		signal += ss3 * 1920; 
	double RC_discharge = RC_capacitor_charge - (double)signal; 
	RC_capacitor_charge = signal; 
	RC_capacitor_output -= RC_discharge; 
	double filtered_output = fir_basic( (double)((int)RC_capacitor_output) ); 
	RC_capacitor_output *= RC_capacitor_discharge_relaxation; 
	delay++; if( (delay&3)==0 )
	{
		pomi = (int)( -filtered_output );
		if( pomi<-32767 ) pomi = -32767; else if( pomi>32767 ) pomi = 32767;
		sndBuf[sndBufPtr] = (WORD)pomi ;
		sndBufPtr = (sndBufPtr+sampleStep)&16383;
	}
}

OutputFunction output_function[2] = { OutputFunction_Atari, OutputFunction_PCMWave };


void pus_zero( int n )
{
int i,ch,ss;
DWORD pp;

	pp = pokeyClockCounter + (pcc1564 - pokeyClockCounter64k);
	ss = sndBufPtrUpp; 
	i = n;
	do
	{
		pokeyClockCounter++;
		if( pokeyClockCounter>=pp )
		{
			pp = pokeyClockCounter + pcc1564;
			ch = 0; { if( --divideByN[ch]==0 ) { generateIRQ0=true; divideByN[ch] = divideByN_Latch2[ch]; Channel0Distortion(); } }
			ch = 1; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel1Distortion(); } }
			ch = 2; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel2Distortion(); switch_J3_Q_state[0] = signal_state_out[0]; } }
			ch = 3; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel3Distortion(); switch_J3_Q_state[1] = signal_state_out[1]; } }
		}
		ss-=0x10000;
		if( ss<0 )
		{
			ss += samplerRateOver;
			output_function[selected_output_type]();
		}
	} while(--i);
	sndBufPtrUpp = ss;
	pokeyClockCounter64k = pcc1564 + pokeyClockCounter - pp ;

}

void pus_2h( int n )
{
int i,ch,ss;
DWORD pp;

	pp = pokeyClockCounter + (pcc1564 - pokeyClockCounter64k);
	ss = sndBufPtrUpp; 
	i = n;
	do
	{
		pokeyClockCounter++;
		if( pokeyClockCounter>=pp )
		{
			pp = pokeyClockCounter + pcc1564;
			ch = 0; { if( --divideByN[ch]==0 ) { generateIRQ0=true; divideByN[ch] = divideByN_Latch2[ch]; Channel0Distortion(); } }
			ch = 1; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel1Distortion(); } }
			ch = 3; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel3Distortion(); switch_J3_Q_state[1] = signal_state_out[1]; } }
		}
		ch = 2; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel2Distortion(); switch_J3_Q_state[0] = signal_state_out[0]; } }
		ss-=0x10000;
		if( ss<0 )
		{
			ss += samplerRateOver;
			output_function[selected_output_type]();
		}
	} while(--i);
	sndBufPtrUpp = ss;
	pokeyClockCounter64k = pcc1564 + pokeyClockCounter - pp ;
}

void pus_23h( int n )
{
int i,ch,ss;
DWORD pp;

	pp = pokeyClockCounter + (pcc1564 - pokeyClockCounter64k);
	ss = sndBufPtrUpp; 
	i = n;
	do
	{
		pokeyClockCounter++;
		if( pokeyClockCounter>=pp )
		{
			pp = pokeyClockCounter + pcc1564;
			ch = 0; { if( --divideByN[ch]==0 ) { generateIRQ0=true; divideByN[ch] = divideByN_Latch2[ch]; Channel0Distortion(); } }
			ch = 1; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel1Distortion(); } }
		}
		ch = 2; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel2Distortion(); switch_J3_Q_state[0] = signal_state_out[0]; } }
		ch = 3; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel3Distortion(); switch_J3_Q_state[1] = signal_state_out[1]; } }
		ss-=0x10000;
		if( ss<0 )
		{
			ss += samplerRateOver;
			output_function[selected_output_type]();
		}
	} while(--i);
	sndBufPtrUpp = ss;
	pokeyClockCounter64k = pcc1564 + pokeyClockCounter - pp ;
}

void pus_0h( int n )
{
int i,ch,ss;
DWORD pp;

	pp = pokeyClockCounter + (pcc1564 - pokeyClockCounter64k);
	ss = sndBufPtrUpp; 
	i = n;
	do
	{
		pokeyClockCounter++;
		ch = 0; { if( --divideByN[ch]==0 ) { generateIRQ0=true; divideByN[ch] = divideByN_Latch2[ch]; Channel0Distortion(); } }
		if( pokeyClockCounter>=pp )
		{
			pp = pokeyClockCounter + pcc1564;
			ch = 1; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel1Distortion(); } }
			ch = 2; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel2Distortion(); switch_J3_Q_state[0] = signal_state_out[0]; } }
			ch = 3; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel3Distortion(); switch_J3_Q_state[1] = signal_state_out[1]; } }
		}
		ss-=0x10000;
		if( ss<0 )
		{
			ss += samplerRateOver;
			output_function[selected_output_type]();
		}
	} while(--i);
	sndBufPtrUpp = ss;
	pokeyClockCounter64k = pcc1564 + pokeyClockCounter - pp ;
}

void pus_01h( int n )
{
int i,ch,ss;
DWORD pp;

	pp = pokeyClockCounter + (pcc1564 - pokeyClockCounter64k);
	ss = sndBufPtrUpp; 
	i = n;
	do
	{
		pokeyClockCounter++;
		ch = 0; { if( --divideByN[ch]==0 ) { generateIRQ0=true; divideByN[ch] = divideByN_Latch2[ch]; Channel0Distortion(); } }
		ch = 1; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; if( (AUDCTL & 0x50) == 0x50 ) divideByN[0] = divideByN_Latch2_P[0]; Channel1Distortion(); } }
		if( pokeyClockCounter>=pp )
		{
			pp = pokeyClockCounter + pcc1564;
			ch = 2; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel2Distortion(); switch_J3_Q_state[0] = signal_state_out[0]; } }
			ch = 3; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel3Distortion(); switch_J3_Q_state[1] = signal_state_out[1]; } }
		}
		ss-=0x10000;
		if( ss<0 )
		{
			ss += samplerRateOver;
			output_function[selected_output_type]();
		}
	} while(--i);
	sndBufPtrUpp = ss;
	pokeyClockCounter64k = pcc1564 + pokeyClockCounter - pp ;

}

void pus_02h( int n )
{
int i,ch,ss;
DWORD pp;

	pp = pokeyClockCounter + (pcc1564 - pokeyClockCounter64k);
	ss = sndBufPtrUpp; 
	i = n;
	do
	{
		pokeyClockCounter++;
		ch = 0; { if( --divideByN[ch]==0 ) { generateIRQ0=true; divideByN[ch] = divideByN_Latch2[ch]; Channel0Distortion(); } }
		if( pokeyClockCounter>=pp )
		{
			pp = pokeyClockCounter + pcc1564;
			ch = 1; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel1Distortion(); } }
			ch = 3; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel3Distortion(); switch_J3_Q_state[1] = signal_state_out[1]; } }
		}
		ch = 2; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel2Distortion(); switch_J3_Q_state[0] = signal_state_out[0]; } }
		ss-=0x10000;
		if( ss<0 )
		{
			ss += samplerRateOver;
			output_function[selected_output_type]();
		}
	} while(--i);
	sndBufPtrUpp = ss;
	pokeyClockCounter64k = pcc1564 + pokeyClockCounter - pp ;
}

void pus_012h( int n )
{
int i,ch,ss;
DWORD pp;

	pp = pokeyClockCounter + (pcc1564 - pokeyClockCounter64k);
	ss = sndBufPtrUpp; 
	i = n;
	do
	{
		pokeyClockCounter++;
		ch = 0; { if( --divideByN[ch]==0 ) { generateIRQ0=true; divideByN[ch] = divideByN_Latch2[ch]; Channel0Distortion(); } }
		ch = 1; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch];  if( (AUDCTL & 0x50) == 0x50 ) divideByN[0] = divideByN_Latch2_P[0]; Channel1Distortion(); } }
		if( pokeyClockCounter>=pp )
		{
			pp = pokeyClockCounter + pcc1564;
			ch = 3; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel3Distortion(); switch_J3_Q_state[1] = signal_state_out[1]; } }
		}
		ch = 2; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel2Distortion(); switch_J3_Q_state[0] = signal_state_out[0]; } }
		ss-=0x10000;
		if( ss<0 )
		{
			ss += samplerRateOver;
			output_function[selected_output_type]();
		}
	} while(--i);
	sndBufPtrUpp = ss;
	pokeyClockCounter64k = pcc1564 + pokeyClockCounter - pp ;
}

void pus_023h( int n )
{
int i,ch,ss;
DWORD pp;

	pp = pokeyClockCounter + (pcc1564 - pokeyClockCounter64k);
	ss = sndBufPtrUpp; 
	i = n;
	do
	{
		pokeyClockCounter++;
		ch = 0; { if( --divideByN[ch]==0 ) { generateIRQ0=true; divideByN[ch] = divideByN_Latch2[ch]; Channel0Distortion(); } }
		if( pokeyClockCounter>=pp )
		{
			pp = pokeyClockCounter + pcc1564;
			ch = 1; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel1Distortion(); } }
		}
		ch = 2; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel2Distortion(); switch_J3_Q_state[0] = signal_state_out[0]; } }
		ch = 3; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; if( (AUDCTL & 0x28) == 0x28 ) divideByN[2] = divideByN_Latch2_P[2]; Channel3Distortion(); switch_J3_Q_state[1] = signal_state_out[1]; } }
		ss-=0x10000;
		if( ss<0 )
		{
			ss += samplerRateOver;
			output_function[selected_output_type]();
		}
	} while(--i);
	sndBufPtrUpp = ss;
	pokeyClockCounter64k = pcc1564 + pokeyClockCounter - pp ;
}

void pus_0123h( int n )
{
int i,ch,ss;

	ss = sndBufPtrUpp; 
	i = n;
	do
	{
		pokeyClockCounter++;
		ch = 0; { if( --divideByN[ch]==0 ) { generateIRQ0=true; divideByN[ch] = divideByN_Latch2[ch]; Channel0Distortion(); } }
		ch = 1; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel1Distortion(); } }
		ch = 2; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel2Distortion(); switch_J3_Q_state[0] = signal_state_out[0]; } }
		ch = 3; { if( --divideByN[ch]==0 ) { divideByN[ch] = divideByN_Latch2[ch]; Channel3Distortion(); switch_J3_Q_state[1] = signal_state_out[1]; } }
		ss-=0x10000;
		if( ss<0 )
		{
			ss += samplerRateOver;
			output_function[selected_output_type]();
		}
	} while(--i);
	sndBufPtrUpp = ss;
}

typedef void (*funcPoint2)(int n);

funcPoint2 channelsGeneration[16]={
	&pus_zero,	&pus_zero,	&pus_zero,	&pus_zero,
	&pus_2h,	&pus_23h,	&pus_2h,	&pus_23h,
	&pus_0h,	&pus_0h,	&pus_01h,	&pus_01h,
	&pus_02h,	&pus_023h,	&pus_012h,	&pus_0123h
};

#ifdef _EXCEPTION_
BYTE wasNoExc;
#endif
}; // end of namespace POKEY_NAMESPACE

using namespace NAMESPACENAME;

POKEY_INIT_FUNC
{
int i;
DWORD pol;
BYTE old;

	pol = 0x1FFFF;
	for( i=0; i<0x20000; i++ )
	{
		poly17[i] = (BYTE)(pol&1 ? 15:0);
		pol = pol | (((pol&1) ^ ((pol>>5)&1)) << 17);
		pol>>=1;
	}

	pol = 1;
	for( int i = 0; i < 511; i++ )
	{
		poly9[i] = pol & 1 ? 15:0;
		unsigned int c = (pol >> 3) ^ (pol >> 8);
		pol = ((pol << 1) & 511) | (c & 1);
	}

	for( i=0; i<sizeof(poly4_b); i++ ) // this table repeats after 15
		poly4_b[i] = poly4[i % 15];

	for( i=0; i<sizeof(poly5_b); i++ ) // this table repeats after 31
		poly5_b[i] = poly5[i % 31];

	old = 0;
	for( i=0; i<sizeof(poly4_5_b); i++ ) // this table repeats after 465
	{
		if( poly5[i % 31] )
			old = poly4[i % 15];
		poly4_5_b[i] = old;
	}

}

POKEY_RESET_FUNC
{
int i;

	IRQ_EN		= 0x00;
	IRQ_ST		= 0x00;
	IRQ_line	= 0x00;

	poly4Counter = 0;
	poly5Counter = 0;
	poly4_5Counter = 0;
	pokeyClockCounter = 0;
	pokeyClockCounter64k = 0;
	pcc1564 = 28;
	oldValI = 0;
	oldVal	=0.0;

	for( i=0; i<4; i++ )
	{
		divideByN[i] = 1;
		divideByN_Latch[i] = 0;
		divideByN_Latch2[i] = 0;
		switch_J2_signal_Q[i] = 0;
		signal_state_out[i] = 0;
		switch_J3_Q_state[i] = 0;
		switch_J3_Q_stateAND[i] = 0;
		audioControl_Latch[i] = 0;
		audioControl_Latch2[i] = 0;
		audioControl_Latch_Digi[i] = 0;
		freq_sequre[i] = 0xFF;
	}

	for( i=0; i<16; i++ )
		POKEY_WRITE_2FUNC( 0xD200+i, 0 );
	AUDCTL = 0;
//	POKEY_WRITE_2FUNC( 0xD208, 0x28 );
	POKEY_WRITE_2FUNC( 0xD208, 0x00 );

	memset( fir_buffer, 0, sizeof(fir_buffer) );

	sndBufPtrUpp = 0;
	delay = 0;
#ifdef _EXCEPTION_
	wasNoExc = 1;
#endif

}

POKEY_UPDATESOUND_FUNC
{
#ifdef _EXCEPTION_
EXCEPTION_POINTERS *ep;
	__try
	{
#endif

	channelsGeneration[ (AUDCTL>>3)&15 ](n);

#ifdef _EXCEPTION_
	}
	__except( ep = GetExceptionInformation(), 1 )
	{
		if( wasNoExc )
		{
			// now we should just stop playing
		}
		wasNoExc = 0;
	}
#endif
}


POKEY_UPDATECOUNT_FUNC
{

	pokeyClockCounter = pokeyClockCounter & 0x7FFFFFFF;
	poly4Counter = (int)(((DWORD)(poly4Counter+pokeyClockCounter)) % 15) - pokeyClockCounter;
	poly5Counter = (int)(((DWORD)(poly5Counter+pokeyClockCounter)) % 31) - pokeyClockCounter;
	poly4_5Counter = (int)(((DWORD)(poly4_5Counter+pokeyClockCounter)) % 465) - pokeyClockCounter;

}

#undef SetupChannels01
#undef SetupChannels23

#define SetupChannels01\
			switch( AUDCTL&0x50 )\
			{\
				case 0x00:\
					divideByN_Latch2[0] = divideByN_Latch[0]+1;\
					divideByN_Latch2[1] = divideByN_Latch[1]+1;\
					if( ((audioControl_Latch[0]&0xB0)==0xA0) && (divideByN_Latch2[0]<4) )\
						freq_sequre[0] = 0;\
					else\
						freq_sequre[0] = 15;\
					if( ((audioControl_Latch[1]&0xB0)==0xA0) && (divideByN_Latch2[1]<4) )\
						freq_sequre[1] = 0;\
					else\
						freq_sequre[1] = 15;\
					break;\
				case 0x10:\
					divideByN_Latch2[0] = divideByN_Latch[0]+1;\
					divideByN_Latch2[1] = divideByN_Latch[1]*256+divideByN_Latch[0] + 1;\
					if( ((audioControl_Latch[0]&0xB0)==0xA0) && (divideByN_Latch2[0]<4) )\
						freq_sequre[0] = 0;\
					else\
						freq_sequre[0] = 15;\
					if( ((audioControl_Latch[1]&0xB0)==0xA0) && (divideByN_Latch2[1]<4) )\
						freq_sequre[1] = 0;\
					else\
						freq_sequre[1] = 15;\
					break;\
				case 0x40:\
					divideByN_Latch2[0] = divideByN_Latch[0] + 4;\
					divideByN_Latch2[1] = divideByN_Latch[1]+1;\
					if( ((audioControl_Latch[0]&0xb0)==0xA0) && (divideByN_Latch2[0]<0x50) )\
						freq_sequre[0] = 0;\
					else\
						freq_sequre[0] = 15;\
					if( ((audioControl_Latch[1]&0xB0)==0xA0) && (divideByN_Latch2[1]<4) )\
						freq_sequre[1] = 0;\
					else\
						freq_sequre[1] = 15;\
					break;\
				case 0x50:\
					divideByN_Latch2[0] = 256;\
					divideByN_Latch2_P[0] = divideByN_Latch[0] + 7;\
					divideByN_Latch2[1] = divideByN_Latch[1]*256+divideByN_Latch[0] + 7;\
					if( ((audioControl_Latch[1]&0xB0)==0xA0) && (divideByN_Latch2[1]<0x50) )\
						freq_sequre[1] = 0;\
					else\
						freq_sequre[1] = 15;\
					break;\
			}

#define SetupChannels23\
			switch( AUDCTL&0x28 )\
			{\
				case 0x00:\
					divideByN_Latch2[2] = divideByN_Latch[2]+1;\
					divideByN_Latch2[3] = divideByN_Latch[3]+1;\
					if( ((audioControl_Latch[2]&0xB0)==0xA0) && (divideByN_Latch2[2]<4) )\
						freq_sequre[2] = 0;\
					else\
						freq_sequre[2] = 15;\
					if( ((audioControl_Latch[3]&0xB0)==0xA0) && (divideByN_Latch2[3]<4) )\
						freq_sequre[3] = 0;\
					else\
						freq_sequre[3] = 15;\
					break;\
				case 0x08:\
					divideByN_Latch2[2] = divideByN_Latch[2]+1;\
					divideByN_Latch2[3] = divideByN_Latch[3]*256+divideByN_Latch[2] + 1;\
					if( ((audioControl_Latch[2]&0xB0)==0xA0) && (divideByN_Latch2[2]<4) )\
						freq_sequre[2] = 0;\
					else\
						freq_sequre[2] = 15;\
					if( ((audioControl_Latch[3]&0xB0)==0xA0) && (divideByN_Latch2[3]<4) )\
						freq_sequre[3] = 0;\
					else\
						freq_sequre[3] = 15;\
					break;\
				case 0x20:\
					divideByN_Latch2[2] = divideByN_Latch[2] + 4;\
					divideByN_Latch2[3] = divideByN_Latch[3] + 1;\
					if( ((audioControl_Latch[2]&0xB0)==0xA0) && (divideByN_Latch2[2]<0x50) )\
						freq_sequre[2] = 0;\
					else\
						freq_sequre[2] = 15;\
					if( ((audioControl_Latch[3]&0xB0)==0xA0) && (divideByN_Latch2[3]<4) )\
						freq_sequre[3] = 0;\
					else\
						freq_sequre[3] = 15;\
					break;\
				case 0x28:\
					divideByN_Latch2[2] = 256;\
					divideByN_Latch2_P[2] = divideByN_Latch[2] + 7;\
					divideByN_Latch2[3] = divideByN_Latch[3]*256+divideByN_Latch[2] + 7;\
					if( ((audioControl_Latch[3]&0xB0)==0xA0) && (divideByN_Latch2[3]<0x50) )\
						freq_sequre[3] = 0;\
					else\
						freq_sequre[3] = 15;\
					break;\
			}
